{$R+}
{po materialam paketa LAOLA}
{terminol.: sb, bb, sbd, bbd - small block, big block, ~ depot}

Program h; uses dos;

 var b:file of byte;
 var n1,n2,n3,n4,c1:byte; v2:word; v4,l1_,l2:longint;
 var pp:longint;
 var i,j:longint;
 var big_block_size,small_block_size:word;
 var num_of_bbd_blocks,root_startblock:longint;
 var sbd_startblock,ext_startblock,num_of_ext_blocks:longint;
 var sb_startblock:longint;
 var maxsmallblock,maxblock,todo,num:longint;
 var bbd_list:array[1..10] of longint;
 var bbd,bbd_:array[0..4095] of longint; n_bbd:integer;
 type ceph_=array[1..40] of longint;
 var sbd_list:ceph_; n_sbd_list:integer;
 var root_list:ceph_; n_root_list:integer;
 var sb_list:ceph_; n_sb_list:integer;
 var max_in_header,n_bbd_list:integer;
 const header_size:longint=512;
 const l1:longint=1;
 var o,next:longint;
 var debug,outpu:boolean;
 label prodo;
 
 procedure ust0(sme:longint); begin seek(b,sme); end;

 type s2=string[2]; s4=string[4]; s8=string[8];
 function sb(c:byte):s2;
  const s:array[0..15] of char='0123456789ABCDEF';
 begin sb:=s[c div 16]+s[c mod 16]; end;
 function sw(c:word):s4;
 begin sw:=sb(hi(c))+sb(lo(c)); end;

 function sl(c:longint):s8;
  var ss:s8;
  var w:array[1..2] of word; cc:longint absolute w;
 begin
  cc:=c;
  ss:=sw(w[2])+sw(w[1]);
  sl:=ss;
 end;

 function h1(sme:longint):byte; var n1:byte;
 begin
  ust0(sme); read(b,n1); h1:=n1;
 end;
 function h2(sme:longint):word; const l1:longint=1; var n1,n2:byte;
 begin
  ust0(sme); read(b,n1,n2); 
  h2:=l1*n2*256+n1;
 end;
 function h4(sme:longint):longint; 
  const l1:longint=1; var n1,n2,n3,n4:byte; v4:longint;
 begin
  ust0(sme); read(b,n1,n2,n3,n4); v4:=((l1*n4*256+n3)*256+n2)*256+n1;
  {writeln('     h4: sme,v4= ',sl(sme),' ',sl(v4));}
  h4:=v4;
 end;

 function obrc(c:byte):char; var c1:char;
 begin
  if (c<$20) or (c>=$FF) then c1:='.' else c1:=chr(c); obrc:=c1;
 end;

 procedure izobr(base,sme:longint; typ:byte; comment:string);
  const l1:longint=1; {n1..n4,v2,v4 - v gol. prog. dl`a posled. ispol`z.}
 begin
  write(sl(base),' ',sl(sme),' ',sl(base+sme),' ');
  ust0(base+sme);
  case typ of
   1: begin
         read(b,n1);
         write('      ',sb(n1),'    ',obrc(n1),' ',n1:9);
        end;
   2: begin
         read(b,n1,n2); v2:=l1*n2*256+n1;
         write('    ',{sw(v2),}sb(n1),sb(n2),'   ',obrc(n1),obrc(n2),' ',v2:9);
        end;
   4: begin
         read(b,n1,n2,n3,n4); v4:=((l1*n4*256+n3)*256+n2)*256+n1;
         write({sl(v4),}sb(n1),sb(n2),sb(n3),sb(n4),' ',
           obrc(n1),obrc(n2),obrc(n3),obrc(n4),' ',v4:9);
        end;
   else begin write('typ=',typ,' - ?; '); end;
  end {case};
  writeln(' ',comment);
 end;

{--------}

 var tipy:array[-1..511] of string[8];
 var bb:file of byte;

procedure ceph(n0:integer; var a:ceph_; var na:integer; s,s0:string);
 var j,pp:longint; k:integer;
begin
 na:=0; j:=n0; repeat
  na:=na+1; a[na]:=j; j:=bbd[j]; write(na:5,a[na]:5,'  ');
  if (tipy[a[na]]='?       ') then tipy[a[na]]:=s;
  if ((tipy[a[na]])<>s) and (tipy[a[na]]<>s0) then begin
   writeln(a[na]:5,' /',tipy[a[na]],'/ - !!!'); halt;
  end;
  pp:=Header_Size+a[na]*big_block_size;
  write(sl(pp),'  ');
  for k:=1 to 8 do begin c1:=h1(pp+k-1); write(sb(c1)); end; write('  ');
  for k:=1 to 32 do begin c1:=h1(pp+k-1); write(obrc(c1)); end; writeln;
  for k:=1 to 512 do begin c1:=h1(pp+k-1); write(bb,c1); end;
 until j=-2;
 writeln('-----');
end;

 procedure show_bloki; var pp:longint; i,k:integer;
 begin
  writeln('--------');
  for i:=-1 to maxblock do begin
   if i=-1 then pp:=0 else pp:=Header_Size+i*big_block_size;
   write(i:4,' ',tipy[i],' ',sl(pp),'  ');
   for k:=1 to 8 do begin c1:=h1(pp+k-1); write(sb(c1)); end; write('  ');
   for k:=1 to 32 do begin c1:=h1(pp+k-1); write(obrc(c1)); end; writeln;
  end;
  writeln('--------');
 end;

 var f_sbd:file of longint;
 type a64=array[0..63] of byte; a128=array[0..127] of byte;
   a512=array[0..511] of byte;
 var f_root:file of a128;
 var f_sb,bb_:file of a64; f_bb,bb__:file of a512;
 var sbd,sbd_:array[0..999] of longint; n_sbd:longint;
 var n,dlina64,dlina512:longint;
 var b64:a64; b128:a128; b512:a512;
 var imq:string[8];
 var bbb:text;
 type root_entry=record
  a:array[1..$40] of byte;
  siznam:word;
  tip,tip_:byte;
  prev,next,dir:longint;
  b:array[1..$24] of byte;
  startbl,siz,dupa:longint;
 end;
 var root_e:root_entry absolute b128; siznam_:integer;

procedure show_root;
 var i:longint;
begin
 {wywodim zagolowki iz root; chto im sootw. w small block'ah - neqsno.}
 assign(f_root,'root'); reset(f_root);
 for i:=0 to filesize(f_root)-1 do begin
  read(f_root,b128);
  siznam_:=root_e.siznam div 2;
  if siznam_>0 then siznam_:=siznam_-1; {ubir. $00 na konce}
  write(bbb,i:4,' ');
  for j:=0 to siznam_-1 do write(bbb,obrc(b128[j*2]));
  for j:=siznam_ to 31 do begin
   if (j-siznam_=0) and (siznam_<>0) then write(bbb,' ') else write(bbb,'.');
  end;
  with root_e do begin
   if      tip=5 then write(bbb,' r') {root}
   else if tip=1 then write(bbb,' d') {"directory" (smysl neqsen)}
   else if tip=2 then write(bbb,' F') {fajl}
   else write(bbb,' -');
   if prev=-1 then write(bbb,'   -') else write(bbb,prev:4);
   if next=-1 then write(bbb,'   -') else write(bbb,next:4);
   if dir =-1 then write(bbb,'   -') else write(bbb,dir :4);
   if (tip=5) or (siz>=4096) then write(bbb,' / b') 
   else if siz=0 then write(bbb,' /  ')
   else write(bbb,' / s');
   if siz>0 then write(bbb,startbl:2) else write(bbb,' -');
   write(bbb,' ',siz:6);
  end;
  writeln(bbb);
 end;
 close(f_root);
 writeln(bbb,' Predp.: b0 = bbd (pole dliny ignor.), b3 = sb (ne root!).');
 writeln(bbb,'--------');
end;

Begin
 if (paramcount<1) or (paramcount>2) then begin
  writeln('Obr.: prog infile [-do];');
  writeln('  -d -> debug; -o -> output files.');
  halt;
 end;
 if pos('d',paramstr(2))>0 then debug:=true else debug:=false;
 if pos('o',paramstr(2))>0 then outpu:=true else outpu:=false;
 {al:=true;}
 assign(b,ParamStr(1));
 filemode:=0; reset(b);
 assign(bbb,'oglawl.txt'); rewrite(bbb);
 writeln(bbb,'           ',paramstr(1):12,' ');
 l1_:=h4(0); l2:=h4(4); if not ((l1_=$E011CFD0) and (l2=$E11AB1A1)) then begin
  ust0(0); writeln('Nachalo: ');
  for i:=1 to 8 do begin read(b,c1); write(' ',sb(c1)); end;
  writeln('  - ne D0 CF 11 E0 A1 B1 1A E1 .');
  halt;
 end;
 {-----}
 izobr(0,$1E,2,'2^...=big_block_size');
 i:=1; for j:=1 to v2 do i:=i*2; big_block_size:=i;
 writeln('  big_block_size=  ',sw(big_block_size),' ',big_block_size:5);
 izobr(0,$20,2,'2^...=small_block_size');
 i:=1; for j:=1 to v2 do i:=i*2; small_block_size:=i;
 writeln('  small_block_size=',sw(small_block_size),' ',small_block_size:5);
 {-----}
 izobr(0,$2C,4,'num_of_bbd_blocks'); num_of_bbd_blocks:=v4; {big block depot}
 izobr(0,$30,4,'root_startblock'); root_startblock:=v4;
 izobr(0,$3C,4,'sbd_startblock'); sbd_startblock:=v4; {small block depot}
 izobr(0,$44,4,'ext_startblock'); ext_startblock:=v4;
 izobr(0,$48,4,'num_of_ext_blocks'); num_of_ext_blocks:=v4;
 writeln;

 maxblock:=((filesize(b)-header_size) div big_block_size)-1;
 writeln('maxblock=',sl(l1*maxblock),' (',maxblock:5,')');
 if maxblock<1 then begin writeln('maxblock=',maxblock,' !!!'); halt; end;

 tipy[-1]:='header  '; for i:=0 to maxblock do tipy[i]:='?       ';
 tipy[root_startblock]:='root_sta';
 tipy[sbd_startblock]:='sbd_star';
 if ext_startblock<>-2 then writeln('ext_startblock<>-2 !!!');

 pp:=header_size+root_startblock*big_block_size+$78; v4:=h4(pp);
 maxsmallblock:=trunc(v4/small_block_size-1);
 writeln('  pp,v4,maxsmallblock=',sl(pp),' ',sl(v4),' ',sl(maxsmallblock),
   ' (',maxsmallblock:5,')');

 pp:=header_size+root_startblock*big_block_size+$74; sb_startblock:=h4(pp);
 writeln('  pp,sb_startblock=',sl(pp),' ',sl(sb_startblock));
 
 tipy[sb_startblock]:='sb_start'; 

 {read big block depot}
 max_in_header:=(header_size-$4C) div 4;
 writeln('max_in_header=',sl(max_in_header));

 num:=num_of_bbd_blocks;
 if max_in_header<num then begin
  writeln('num_of_bbd_blocks, max_in_header:',num:5,max_in_header:5,
    ' - bbd_list ne vlazit v header !!!'); {sm. nizhe obrabotku etogo sluchaja}
  num:=max_in_header;
 end;

 writeln(' bbd_list (iz header''a):');
 for i:=1 to num do begin
  v4:=h4($4C+4*(i-1)*l1); bbd_list[i]:=v4; writeln(i:5,' ',sl(v4));
  tipy[v4]:='bbd     ';
 end; n_bbd_list:=num;
 writeln(' bbd_list - konec.');

 {show_bloki;}

 {-----}

 {real`no sluchaev, kogda bbd_list ne vlazit v header, ne popadalos`,
   poetomu etot uchastok ne otlazhivals`a.
 }
 todo:=num_of_bbd_blocks-num; {>0 => bbd_list ne vlez v header}
 next:=ext_startblock;
 writeln('todo,next=',todo:5,next:5);
 if todo>0 then begin writeln('est ext-bloki - NE OTLAZHENO !!!'); end;
 while todo>0 do begin
  num:=todo;
  if todo>((big_block_size-4) div 4) then num:=(big_block_size-4) div 4;
  o:=header_size + next*big_block_size;
  for i:=1 to num do begin
   v4:=h4(o+4*(i-1));
   n_bbd_list:=n_bbd_list+1;
   bbd_list[n_bbd_list]:=v4;
  end;
  todo:=todo-num;
  next:=h4(o+l1*4*num);
 end;

 {-----}

 writeln('--------');
 if debug then writeln('  bbd_list (faktich. - spisok ispol`z. bol`shikh blokov):');
 n_bbd:=-1;
 for i:=1 to n_bbd_list do begin
  pp:=header_size+l1*bbd_list[i]*big_block_size;
  if debug then writeln('  ',i,' ',sl(bbd_list[i]),' ',sl(pp));
  repeat
   n_bbd:=n_bbd+1;
   bbd[n_bbd]:=h4(pp+(n_bbd mod 128)*4);
   if debug then writeln('  ',n_bbd,' ',bbd[n_bbd]);
  until (n_bbd=maxblock) or ((n_bbd mod 128)=127);
 end;
 writeln('--------');

 if debug then begin
  writeln(bbb,' bbd:');
  for j:=0 to n_bbd {bez -1 !!!} do writeln(bbb,j:5,bbd[j]:5);
  writeln(bbb,'--------');
 end;

 writeln('  sbd:'); assign(bb,'sbd'); rewrite(bb);
 ceph(sbd_startblock,sbd_list,n_sbd_list,'sbd     ','sbd_star'); close(bb);
 writeln('  root:'); assign(bb,'root'); rewrite(bb);
 ceph(root_startblock,root_list,n_root_list,'root    ','root_sta'); close(bb);
 writeln('  sb:'); assign(bb,'sb'); rewrite(bb);
 ceph(sb_startblock,sb_list,n_sb_list,'sb      ','sb_start'); close(bb);

 if debug then show_bloki;

 {-----}
 {wwodim small block depot == opis. cepochek w small block'ah}
 assign(f_sbd,'sbd'); reset(f_sbd);
 n_sbd:=filesize(f_sbd); writeln('n_sbd=',n_sbd);
 for i:=0 to n_sbd-1 do read(f_sbd,sbd[i]);
 close(f_sbd);

 if debug then begin
  writeln(bbb,' sbd:');
  for j:=0 to n_sbd-1 do if sbd[j]<>-1 {-1 = neispolxz.} then begin
   writeln(bbb,j:5,sbd[j]:5); 
  end;
  writeln(bbb,'--------');
 end;
 {-----}

 show_root;

 {-----}

 {ishchem nachala cepochek}
 for i:=0 to n_sbd do sbd_[i]:=0;
 for i:=0 to n_sbd-1 do begin
  n:=sbd[i];
  {writeln('i,n=',i:5,' ',n:5);}
  if n>=0 then sbd_[n]:=1;
 end;
 for i:=0 to n_bbd do bbd_[i]:=0;
 for i:=0 to n_bbd do begin
  n:=bbd[i];
  {writeln('i,n=',i:5,' ',n:5);}
  if n>=0 then bbd_[n]:=1;
 end;
 {napr., 0->1, 1->2 => sbd_[1] i sbd_[2] poluchat znachenie 1,
   chto oznach., chto eto 1-j i 2-j klastery ne qwlqjutsa nachal`nymi
   w cepochke.
 }
 {-----}
 if not outpu then goto prodo;
 {wywodim "fajly" iz oblasti small block'ow}
 assign(f_sb,'sb'); reset(f_sb);
 for i:=0 to n_sbd-1 do if (sbd_[i]=0) and (sbd[i]<>-1) then begin
  writeln(bbb,'Nachalo small-fajla s',i);
  str(i,imq);
  assign(bb_,'s'+imq+'.dat'); rewrite(bb_);
  j:=i; dlina64:=0; repeat
   write(bbb,j:2,'- ');
   seek(f_sb,j); read(f_sb,b64); write(bb_,b64);
   inc(dlina64);
   j:=sbd[j];
  until j=-2; writeln(bbb);
  close(bb_);
  writeln(bbb,'dlina64=',dlina64); writeln(bbb);
 end;
 close(f_sb);
 writeln(bbb,'--------');
 {-----}
 {analogichno dlq big block'ow}
 assign(f_bb,paramstr(1)); reset(f_bb);
 for i:=0 to n_bbd do if (bbd_[i]=0) and ((bbd[i]>0) or (bbd[i]=-2) or (bbd[i]=-3)) then begin
  write(bbb,'Nachalo big-fajla b',i);
  if i=0 then write(bbb,' (ozhid. bbd)');
  if i=1 then write(bbb,' (ozhid. root)');
  if i=2 then write(bbb,' (ozhid. sbd)');
  if i=3 then write(bbb,' (ozhid. sb (ne root!))');
  writeln(bbb);
  str(i,imq);
  assign(bb__,'b'+imq+'.dat'); rewrite(bb__);
  j:=i; dlina512:=0; repeat
   write(bbb,j:2,'- ');
   seek(f_bb,j+1); {j+1 - propusk. zagolowok} read(f_bb,b512); write(bb__,b512);
   inc(dlina512);
   j:=bbd[j];
  until j<0; {norm. prizn. konca = -2; -3 => sistemn.?} writeln(bbb);
  close(bb__);
  writeln(bbb,'dlina512=',dlina512); writeln(bbb);
 end;
 close(f_bb);
 prodo:
 {-----}
 writeln(bbb,'-------------');
 close(bbb);
End.
